import { _Callback, AsyncCallbackFn, CallbackFn, Context, PositionType } from "./types";
import { WalkNode } from "./node";
export declare class _CallbackStacker<T extends CallbackFn, Rt> {
    private ctx;
    private executor;
    constructor(ctx: Context<T>, executor: (callbacks: _Callback<T>[], node: WalkNode) => Rt);
    static forSync<T extends CallbackFn>(ctx: Context<T>): _CallbackStacker<CallbackFn, void>;
    static forAsync<T extends CallbackFn>(ctx: Context<T>): _CallbackStacker<AsyncCallbackFn, void | Promise<void>>;
    private _matchCallbacks;
    private lookup;
    pushToStack(node: WalkNode, position: PositionType): void;
    executeOne(node: WalkNode, position: PositionType): Rt;
    execute(nodeId: number): Generator<Rt>;
}
